# Class HashMap<K,V>

java.lang.Object
java.util.AbstractMap<K,V>
java.util.HashMap<K,V>

All Implemented Interfaces:
  `Map<K,V>`

Direct Known Subclasses:
  `LinkedHashMap, Properties`

public class HashMap<K,V> extends AbstractMap<K,V> implements Map<K,V>
HashMap is an implementation of Map. All optional operations (adding and removing) are supported. Keys and values can be any objects.

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class AbstractMap

  `AbstractMap.SimpleEntry<K,V>, AbstractMap.SimpleImmutableEntry<K,V>`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `HashMap()`
  Constructs a new empty `HashMap` instance.
  `HashMap(int capacity)`
  Constructs a new `HashMap` instance with the specified capacity.
  `HashMap(int capacity, float loadFactor)`
  Constructs a new `HashMap` instance with the specified capacity and load factor.
  `HashMap(Map<? extends K, ? extends V> map)`
  Constructs a new `HashMap` instance containing the mappings from the specified map.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `clear()`
  Removes all mappings from this hash map, leaving it empty.
  `boolean`
  `containsKey(Object key)`
  Returns whether this map contains the specified key.
  `boolean`
  `containsValue(Object value)`
  Returns whether this map contains the specified value.
  `Set<Map.Entry<K,V>>`
  `entrySet()`
  Returns a set containing all of the mappings in this map.
  `V`
  `get(Object key)`
  Returns the value of the mapping with the specified key.
  `boolean`
  `isEmpty()`
  Returns whether this map is empty.
  `Set<K>`
  `keySet()`
  Returns a set of the keys contained in this map.
  `V`
  `put(K key, V value)`
  Maps the specified key to the specified value.
  `void`
  `putAll(Map<? extends K, ? extends V> map)`
  Copies all the mappings in the specified map to this map.
  `V`
  `remove(Object key)`
  Removes the mapping with the specified key from this map.
  `int`
  `size()`
  Returns the number of elements in this map.
  `Collection<V>`
  `values()`
  Returns a collection of the values contained in this map.

  ### Methods inherited from class AbstractMap

  `equals, hashCode, toString`

  ### Methods inherited from class Object

  `clone, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface Map

  `equals, hashCode`

- ## Constructor Details

  - ### HashMap

    public HashMap()
    Constructs a new empty `HashMap` instance.

  - ### HashMap

    public HashMap(int capacity)
    Constructs a new `HashMap` instance with the specified capacity.
    Parameters:
      `capacity` - the initial capacity of this hash map.
    Throws:
      `IllegalArgumentException` - when the capacity is less than zero.

  - ### HashMap

    public HashMap(int capacity, float loadFactor)
    Constructs a new `HashMap` instance with the specified capacity and load factor.
    Parameters:
      `capacity` - the initial capacity of this hash map.
      `loadFactor` - the initial load factor.
    Throws:
      `IllegalArgumentException` - when the capacity is less than zero or the load factor is less or equal to zero.

  - ### HashMap

    public HashMap(Map<? extends K, ? extends V> map)
    Constructs a new `HashMap` instance containing the mappings from the specified map.
    Parameters:
      `map` - the mappings to add.

- ## Method Details

  - ### clear

    public void clear()
    Removes all mappings from this hash map, leaving it empty.
    Specified by:
      `clear` in interface `Map<K,V>`
    Overrides:
      `clear` in class `AbstractMap<K,V>`
    See Also:
      - `isEmpty()`
      - `size()`

  - ### containsKey

    public boolean containsKey(Object key)
    Returns whether this map contains the specified key.
    Specified by:
      `containsKey` in interface `Map<K,V>`
    Overrides:
      `containsKey` in class `AbstractMap<K,V>`
    Parameters:
      `key` - the key to search for.
    Returns:
      `true` if this map contains the specified key, `false` otherwise.

  - ### containsValue

    public boolean containsValue(Object value)
    Returns whether this map contains the specified value.
    Specified by:
      `containsValue` in interface `Map<K,V>`
    Overrides:
      `containsValue` in class `AbstractMap<K,V>`
    Parameters:
      `value` - the value to search for.
    Returns:
      `true` if this map contains the specified value, `false` otherwise.

  - ### entrySet

    public Set<Map.Entry<K,V>> entrySet()
    Returns a set containing all of the mappings in this map. Each mapping is an instance of `Map.Entry`. As the set is backed by this map, changes in one will be reflected in the other.
    Specified by:
      `entrySet` in interface `Map<K,V>`
    Specified by:
      `entrySet` in class `AbstractMap<K,V>`
    Returns:
      a set of the mappings.

  - ### get

    public V get(Object key)
    Returns the value of the mapping with the specified key.
    Specified by:
      `get` in interface `Map<K,V>`
    Overrides:
      `get` in class `AbstractMap<K,V>`
    Parameters:
      `key` - the key.
    Returns:
      the value of the mapping with the specified key, or `null` if no mapping for the specified key is found.

  - ### isEmpty

    public boolean isEmpty()
    Returns whether this map is empty.
    Specified by:
      `isEmpty` in interface `Map<K,V>`
    Overrides:
      `isEmpty` in class `AbstractMap<K,V>`
    Returns:
      `true` if this map has no elements, `false` otherwise.
    See Also:
      - `size()`

  - ### keySet

    public Set<K> keySet()
    Returns a set of the keys contained in this map. The set is backed by this map so changes to one are reflected by the other. The set does not support adding.
    Specified by:
      `keySet` in interface `Map<K,V>`
    Overrides:
      `keySet` in class `AbstractMap<K,V>`
    Returns:
      a set of the keys.

  - ### put

    public V put(K key, V value)
    Maps the specified key to the specified value.
    Specified by:
      `put` in interface `Map<K,V>`
    Overrides:
      `put` in class `AbstractMap<K,V>`
    Parameters:
      `key` - the key.
      `value` - the value.
    Returns:
      the value of any previous mapping with the specified key or `null` if there was no such mapping.

  - ### putAll

    public void putAll(Map<? extends K, ? extends V> map)
    Copies all the mappings in the specified map to this map. These mappings will replace all mappings that this map had for any of the keys currently in the given map.
    Specified by:
      `putAll` in interface `Map<K,V>`
    Overrides:
      `putAll` in class `AbstractMap<K,V>`
    Parameters:
      `map` - the map to copy mappings from.
    Throws:
      `NullPointerException` - if `map` is `null`.

  - ### remove

    public V remove(Object key)
    Removes the mapping with the specified key from this map.
    Specified by:
      `remove` in interface `Map<K,V>`
    Overrides:
      `remove` in class `AbstractMap<K,V>`
    Parameters:
      `key` - the key of the mapping to remove.
    Returns:
      the value of the removed mapping or `null` if no mapping for the specified key was found.

  - ### size

    public int size()
    Returns the number of elements in this map.
    Specified by:
      `size` in interface `Map<K,V>`
    Overrides:
      `size` in class `AbstractMap<K,V>`
    Returns:
      the number of elements in this map.

  - ### values

    public Collection<V> values()
    Returns a collection of the values contained in this map. The collection is backed by this map so changes to one are reflected by the other. The collection supports remove, removeAll, retainAll and clear operations, and it does not support add or addAll operations.

    This method returns a collection which is the subclass of AbstractCollection. The iterator method of this subclass returns a "wrapper object" over the iterator of map's entrySet(). The `size` method wraps the map's size method and the `contains` method wraps the map's containsValue method.

    The collection is created when this method is called for the first time and returned in response to all subsequent calls. This method may return different collections when multiple concurrent calls occur, since no synchronization is performed.

    Specified by:
      `values` in interface `Map<K,V>`
    Overrides:
      `values` in class `AbstractMap<K,V>`
    Returns:
      a collection of the values contained in this map.